#ifndef __REGISTRY_H_
#define __REGISTRY_H_

#include "share.h"

class THIRegistry:public TDebug
{
   private:
   string RData;
   string IntToHex(int Value,int Dig)
     {
  HI_STRING k = _his("0123456789ABCDEF");
      string s;
      HI_RSTRING buf[10];
         buf[9] = 0;
         int ind = 8;
             while( Value )
              {
          buf[ind--] = k[Value & 0xf];
          Value = Value >> 4;
              }
      while( ind &&(8 - ind < Dig) )
          buf[ind--] = _his('0');
         return string(&buf[ind+1]);
      }    
int HexToInt(string st)
{
   st = st.Lower();
   char *buf;
   #ifdef UNICODE
    buf = new char[st.Length()+1];
    UtoA(st.c_str(),buf,st.Length());
   #else
    buf = st.c_str();
   #endif
   int Result = 0;
   for(int i = 0; i < st.Length(); i++)
    if( (buf[i] >= '0')&&(buf[i] <= '9') )
      Result = (Result << 4) + (buf[i] - '0');
    else if( (buf[i] >= 'a')&&(buf[i] <= 'f') )
      Result = (Result << 4) + (buf[i] - 'a' + 10);
    else break;
   #ifdef UNICODE
    delete buf;
   #endif
   return Result;
} 
   public:
    string _prop_Data;
    string _prop_Key;
    string _prop_Value;
    int _prop_HKey;
    int _prop_DataType;
    bool _prop_NotEmpty;
    
    THI_Event *_data_Data;
    THI_Event *_data_Key;
    THI_Event *_data_Value;
    THI_Event *_data_DataType;    
    THI_Event *_event_onRead;
    THI_Event *_event_onEnumKeys;
    THI_Event *_event_onEnumValues;
    THI_Event *_event_onDelete;    

    THIRegistry() { _data_Data = _data_Key = _data_Value = _event_onRead = NULL; }
    HI_WORK_LOC(THIRegistry,_work_doCreate);    
    HI_WORK_LOC(THIRegistry,_work_doWrite);
    HI_WORK_LOC(THIRegistry,_work_doRead);
    HI_WORK_LOC(THIRegistry,_work_doDeleteKey);
    HI_WORK_LOC(THIRegistry,_work_doDeleteValue);
    HI_WORK_LOC(THIRegistry,_work_doEnumKeys);
    HI_WORK_LOC(THIRegistry,_work_doEnumValues);
    HI_WORK(_var_RData){ CreateData(_Data,_hie(THIRegistry)->RData); }
};

///////////////////////////////////////////////////////////////

const HKEY _HKey[4] = {HKEY_CLASSES_ROOT,HKEY_CURRENT_USER,HKEY_LOCAL_MACHINE,HKEY_USERS};
const int _RTypes[4] = {REG_SZ, REG_DWORD, REG_BINARY, REG_MULTI_SZ};

bool OpenKey(HKEY root, string key, bool CanCreate, HKEY *reg) {
   ULONG disp = 0;
   HKEY TempKey = 0;
   int Access = 0;
   
   if(CanCreate)
     return RegCreateKeyEx(root, PChar(key), 0, NULL, REG_OPTION_NON_VOLATILE, Access, NULL, reg, &disp) == ERROR_SUCCESS;
   else
     return RegOpenKeyEx(root, PChar(key), 0, Access, reg) == ERROR_SUCCESS;
}

void THIRegistry::_work_doWrite(TData &_Data,WORD Index)
{
    string dt = ReadString(_Data,_data_Data,_prop_Data);
    string key = ReadString(_Data,_data_Key,_prop_Key);
    string value = ReadString(_Data,_data_Value,_prop_Value);
    int type = ReadInteger(_Data,_data_DataType,_prop_DataType);
    HKEY reg = NULL;

    if(OpenKey(_HKey[_prop_HKey], key, true, &reg)) {
       unsigned char *Buffer;
       int BufSize;
       int ival;
       int b=0;
       string bin;
       string n =L"";
       string cr=L"\r\n";     
       string end=L"*";
       string sval,sv;
       switch(type) {
          case 0: ///////////////////////////////////////////////////////////////////////STRING       
             dt.Replace(cr,n); 
             Buffer = (unsigned char *)PChar(dt);
             #ifdef UNICODE
             BufSize = dt.Length()*2;
             #else
             BufSize = dt.Length();
             #endif 
RegSetValueEx(reg, PChar(value), 0, _RTypes[type],Buffer,BufSize);             
             break;             
          case 1: ////////////////////////////////////////////////////////////////////////DWORD
             dt.Replace(cr,n);     
             ival = StrToInt(dt);
             Buffer = (unsigned char *)&ival;
             BufSize = sizeof(ival);
RegSetValueEx(reg, PChar(value), 0, _RTypes[type],Buffer,BufSize);             
             break;
          case 2:   /////////////////////////////////////////////////////////////////////////BINARY
             dt.Replace(cr,n);         
             BufSize = dt.Length()/2;
             while(b<BufSize)
                 { 
                  bin=dt.Copy(1,4);
                  bin.Delete(1,2);
                  sv=bin+dt.Copy(1,2);
                  dt.Delete(1,4);
                  ival= HexToInt(sv);  
                    HI_RSTRING buf[2];
                     buf[0] = ival;
                     buf[1] = 0;
                    sval +=((HI_STRING)buf);
                  b++; 
                  } 
                    Buffer = (unsigned char *)PChar(sval);                           
RegSetValueEx(reg, PChar(value), 0, _RTypes[type],Buffer,BufSize);                         
             break;            
           case 3: /////////////////////////////////////////////////////////////////////MULTISTRING
               dt.Replace(cr,end);
               BufSize = dt.Length()*2;
               wchar_t *mString = new wchar_t[BufSize];
               memset(mString,'\0',BufSize);
                  while(dt.PosEx(end,1)>0)
                     {
                     sval= dt.GetTok(end);
                     wcscat(mString,PChar(sval));
                     wcscat(mString, TEXT("$")); 
                     }
               wcscat(mString,PChar(dt));
               wcscat(mString, TEXT("$"));                             
                    
              int mStringLen = wcslen(mString);
              for(int x = 0; x < mStringLen; ++x)
                 {if(mString[x] == '$')
                  mString[x] = '\0'; }          
RegSetValueEx(reg, PChar(value), 0, _RTypes[type],(PBYTE)mString,BufSize);                               
             break;           
                                            
       }
       RegCloseKey(reg);  
    }
}

int GetDataSize(HKEY key, string &value) {
  ULONG DataType;
  ULONG len;
  RegQueryValueEx(key, PChar(value), NULL, &DataType, NULL, &len);
  return len; 
}

void THIRegistry::_work_doRead(TData &_Data,WORD Index)
{
    string key = ReadString(_Data,_data_Key,_prop_Key);
    string value = ReadString(_Data,_data_Value,_prop_Value);
    string mstr,dest,hot,kol,toy;
    HKEY reg = NULL;
     string nul=L"0000";
     string end=L"0A";
     RData = _his("");
    
    if(OpenKey(_HKey[_prop_HKey], key, false, &reg)) 
     {
       ULONG BufSize = GetDataSize(reg, value);
        unsigned char *Buffer = new unsigned char[BufSize];
       ULONG DataType = 0;
       BYTE dwReturn[1024];
       DWORD dwBufSize = sizeof(dwReturn);
        bool s = false;
        int j=0; 
   
       if(RegQueryValueEx(reg, PChar(value), NULL, &DataType,Buffer, &BufSize) == ERROR_SUCCESS) 
         {
          switch(DataType) 
           {
            case REG_SZ:
            case REG_EXPAND_SZ: 
               RData = (HI_STRING)Buffer;
               _hi_onEvent(_event_onRead, RData);
               break;
            case REG_DWORD: 
               RData = IntToStr(*(int*)Buffer);
               _hi_onEvent(_event_onRead, RData);
               break;
            case REG_BINARY:
            RegQueryValueEx(reg, PChar(value), NULL,&DataType,(LPBYTE)dwReturn, &dwBufSize);
                              while (j<dwBufSize)           
                          { toy += IntToHex(dwReturn[j],2);
                              j++; } RData=toy;      
                            _hi_onEvent(_event_onRead,RData);           
               break;   
            case  REG_MULTI_SZ:
            RegQueryValueEx(reg, PChar(value), NULL,&DataType,(LPBYTE)dwReturn, &dwBufSize);        
                     for (int i = 0; i <=dwBufSize; i++) 
                  {            
                   hot = IntToHex(dwReturn[i],2); 
                           if(s==false)
                          { dest=hot;}
                           if(s==true)
                          { kol=hot; }
                           if(s==true)
                          { mstr=kol+dest;s=false;}
                           else s=true;
                        if(mstr==nul)
                        mstr=end;
                        if(s==true)
                        {wchar_t rt=HexToInt(mstr);
                         HI_RSTRING buf[2];
                         buf[0] = rt;
                         buf[1] = 0;
                         toy +=((HI_STRING)buf); }                    
                   }RData=toy; 
          _hi_onEvent(_event_onRead,RData);                                                       
               break;     
          }
        }  
        else {if(_prop_NotEmpty)
         _hi_onEvent(_event_onRead, RData);} 
       RegCloseKey(reg);
     }  
}

   void THIRegistry::_work_doCreate(TData &_Data,WORD Index)
    {
    string key = ReadString(_Data,_data_Key,_prop_Key);
       HKEY reg = NULL;
    OpenKey(_HKey[_prop_HKey], key, true, &reg);
       RegCloseKey(reg);
    }

   void THIRegistry::_work_doDeleteKey(TData &_Data,WORD Index)
     {   
               int empty=0;
        string key = ReadString(_Data,_data_Key,_prop_Key);
           LONG nRes= RegDeleteKey(_HKey[_prop_HKey],PChar(key));
             if(nRes != ERROR_SUCCESS)
               _hi_onEvent(_event_onDelete,(int)empty);
             else _hi_onEvent(_event_onDelete);                      
     }
     
     void THIRegistry::_work_doDeleteValue(TData &_Data,WORD Index)
     {   
        string key = ReadString(_Data,_data_Key,_prop_Key);
        string value = ReadString(_Data,_data_Value,_prop_Value);
              HKEY reg=NULL ;
               int empty=0;
        if(OpenKey(_HKey[_prop_HKey], key, false, &reg))
            { 
              if(RegDeleteValue(reg,PChar(value))!= ERROR_SUCCESS) 
                 _hi_onEvent(_event_onDelete,(int)empty);
              else _hi_onEvent(_event_onDelete);   
               RegCloseKey(reg);
             }
         else _hi_onEvent(_event_onDelete,(int)empty);                 
     } 
     
    void THIRegistry::_work_doEnumKeys(TData &_Data,WORD Index)
           {      string key = ReadString(_Data,_data_Key,_prop_Key);
                  string val = _his("");
                  DWORD dwIndex = 0;
                  DWORD cbName = 256;
                  TCHAR szSubKeyName[256];
                      HKEY reg = NULL;
              if(OpenKey(_HKey[_prop_HKey], key,false, &reg))
 while ((RegEnumKeyEx(reg, dwIndex, szSubKeyName, &cbName, NULL, NULL, NULL, NULL)) != ERROR_NO_MORE_ITEMS )
                     { dwIndex++;
                        cbName = 256; 
                   val = (HI_STRING)szSubKeyName;        
                _hi_onEvent(_event_onEnumKeys,val);}
               else _hi_onEvent(_event_onEnumKeys,(int)dwIndex); 
               RegCloseKey(reg);
       } 
       
    void THIRegistry::_work_doEnumValues(TData &_Data,WORD Index)
           {      string key = ReadString(_Data,_data_Key,_prop_Key);
                  string val = _his("");
                  DWORD dwIndex = 0;
                  DWORD cbName = 256;
                  TCHAR szValueName[256];
                      HKEY reg = NULL;
              if(OpenKey(_HKey[_prop_HKey], key,false, &reg)) 
 while ((RegEnumValue(reg, dwIndex, szValueName, &cbName, NULL, NULL, NULL, NULL)) != ERROR_NO_MORE_ITEMS )
                     { dwIndex++;
                        cbName = 256; 
                   val = (HI_STRING)szValueName;        
                _hi_onEvent(_event_onEnumValues,val);}
              else _hi_onEvent(_event_onEnumValues,(int)dwIndex);  
               RegCloseKey(reg);
       }              
#endif
